/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DSOL                                                     */
/* Tabela : DESTSOL                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_DSOL
BEFORE INSERT OR UPDATE OR DELETE
ON DESTSOL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUDSOL := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0))   OR
         (NVL(:OLD.CDDESTSOLI,0) <> NVL(:NEW.CDDESTSOLI,0)) OR
         (NVL(:OLD.NMDESTSOLI,0) <> NVL(:NEW.NMDESTSOLI,0)) THEN
         :NEW.DTULTATUDSOL := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('DESTSOL', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDDESTSOLI='||:OLD.CDDESTSOLI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE DESTSOL MODIFY DTULTATUDSOL DEFAULT SYSDATE
/
