/*
Tecnisa - Tecnologia em Informtica

Nome: APURAC_RELGESDIRETA

Descrio:
   Procedimento para preparao de dados que sero necessrios
   para os relatrios do contrato de GESTO DIRETA.

Criao:
01/07/99 - Luiz Otvio de Souza

Manutenes:
         20/12/2001 - Alessandra Cristina _ Converso para SqlServer

*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_RELGESDIRETA' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_RELGESDIRETA
GO
CREATE PROCEDURE APURAC_RELGESDIRETA
(  @P_CDFILIAL    VARCHAR(04),
   @P_DATAINI     DATETIME,
   @P_DATAFIN     DATETIME,
   @P_NRAPURACGD  VARCHAR(10),
   @P_CDCLIENTE   VARCHAR(21) = NULL
)
 AS

 /* VARIVEIS PARA CONTROLE DE PARAMETROS */

   DECLARE @STIDMINIEFET     VARCHAR(01);
   DECLARE @STIDQTDEPREC     VARCHAR(01);
   DECLARE @STIDUTEFEPLA     VARCHAR(01);

/* VARIVEIS PARA CONTROLE DE APURAO */

   DECLARE @QTDEMINIEFET   FLOAT;
   DECLARE @V_CDSERVAJUS   VARCHAR(05);
   DECLARE @V_QTEFETREAL   FLOAT;
   DECLARE @V_QTEFETSERV   FLOAT;
   DECLARE @V_QTEFETGRUP   FLOAT;
   DECLARE @V_TTEFETSERV   FLOAT;
   DECLARE @V_VRSERVICO    FLOAT;
   DECLARE @V_VRSERVREAL   FLOAT;
   DECLARE @V_VRPERCCORR   FLOAT;
   DECLARE @V_EXISTE       FLOAT
   DECLARE @V_CDFILIAL     VARCHAR(04);
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDSERVFILI   VARCHAR(05);
   DECLARE @V_CDGRSERVFAT  VARCHAR(03);
   DECLARE @V_DTFATURAM    DATETIME;
   DECLARE @V_VRSERVFATU   FLOAT;
   DECLARE @V_CDTURNO      VARCHAR(01);
   DECLARE @V_VRSERVFATUDT FLOAT;
   DECLARE @V_UTEFETTUR    VARCHAR(01);
   DECLARE @V_CDSERVPREQUI VARCHAR(05);
   DECLARE @V_VRSERVFAEQ   FLOAT;
   DECLARE @V_VRSERVTOTAL  FLOAT;
   DECLARE @V_QTDEREFE     FLOAT;
   DECLARE @V_NMSERVICO    VARCHAR(40);
   DECLARE @V_VRIMPOSTO    FLOAT;
   DECLARE @CUR_MINEFETMES CURSOR;
   DECLARE @CUR_CDFILIAL   VARCHAR(4);
   DECLARE @CUR_NMTURNO    VARCHAR(10);
   DECLARE @CUR_CDSERVFILI VARCHAR(5);
   DECLARE @CUR_QTEFETIVOS NUMERIC;
   DECLARE @CUR_DSMINEFET VARCHAR(400);
   DECLARE @CUR_VRSERVICO NUMERIC;
   DECLARE @CUR_CDPRODUTO VARCHAR(10);
   DECLARE @CUR_DATABASE  DATETIME;
   DECLARE @CUR_CDCLIENTE VARCHAR(21);
   DECLARE @V_IDCLIENPRIN VARCHAR(1);
   DECLARE @V_MIN_VRSERVICO NUMERIC;
   DECLARE @V_MIN_CDTURNO VARCHAR(1);
   DECLARE @V_CDCLIEPRIN VARCHAR(21);
   DECLARE @V_CLIENTE VARCHAR(21);

BEGIN

   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD = @P_CDFILIAL   AND
         NRAPURACGD   = @P_NRAPURACGD;

   /* APAGA OS REGISTROS DA TRAB_APURAC_TU DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_TU
   WHERE CDFILIALAPTU = @P_CDFILIAL   AND
         NRAPURACTU   = @P_NRAPURACGD;

   /* APAGA OS REGISTROS DA TRAB_APURAC_EQ DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_EQ
   WHERE CDFILIALAPEQ = @P_CDFILIAL   AND
         NRAPURACEQ   = @P_NRAPURACGD;

   /* BUSCA OS PARAMETROS DA PARAMGERAL E PARAMFILIAL */
   SELECT @STIDMINIEFET = MAX(SUBSTRING(DSPARAMFATFI,01,1)),
          @STIDQTDEPREC = MAX(SUBSTRING(DSPARAMFATFI,02,1)),
          @STIDUTEFEPLA = MAX(SUBSTRING(DSPARAMFATFI,15,1))
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   /* POR DIA */
   IF (@STIDMINIEFET IS NULL) OR (@STIDMINIEFET = ' ') BEGIN
      SET @STIDMINIEFET = '1';
   END;

   /* POR QUANTIDADE */
   IF (@STIDQTDEPREC IS NULL) OR (@STIDQTDEPREC = ' ') BEGIN
      SET @STIDQTDEPREC = '1';
   END;

   /* NAO UTILIZA EFETIVOS DO PLANEJAMENTO */
   IF (@STIDUTEFEPLA IS NULL) OR (@STIDUTEFEPLA = ' ') BEGIN
      SET @STIDUTEFEPLA = 'N';
   END;
   SELECT @V_CLIENTE = MAX(CDCLIENTE)
     FROM CLIENFILIAL
    WHERE CDFILIAL = @P_CDFILIAL
      AND IDCLIENPRIN = 'S';
   /*ABRE CURSOR QUE IRA INSERIR NAS TABELAS TRAB_APURAC A DIFERENCA DE EFETIVOS POR MES*/
   EXEC TEKNISA.OPENEFETMINCUR  @CUR_MINEFETMES OUTPUT,
                                @P_CDFILIAL,
                                @P_DATAINI,
                                @P_DATAFIN,
                                @STIDUTEFEPLA,
                                ' ';
                                
   FETCH NEXT FROM @CUR_MINEFETMES INTO @CUR_CDFILIAL,
				    					@CUR_NMTURNO,
										@CUR_CDSERVFILI,
										@CUR_QTEFETIVOS,
										@CUR_DSMINEFET,
										@CUR_CDPRODUTO,
										@CUR_DATABASE,
										@CUR_VRSERVICO
         
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @CUR_QTEFETIVOS > 0 BEGIN 

         /*INSERE DIFERENA NA TRAB_APURAC_GD*/
         IF @CUR_NMTURNO IS NULL BEGIN
     
            /* VERIFICA SE UTILIZA EQUIVALENCIA DE SERVICO*/ 
            SELECT @V_CDSERVPREQUI = ISNULL(MAX(CDSERVPREQUI),NULL)
              FROM SERVICO
             WHERE CDSERVFILI = @CUR_CDSERVFILI AND
                   CDFILIAL   = @CUR_CDFILIAL;

            IF @V_CDSERVPREQUI IS NOT NULL BEGIN
               SELECT @V_VRSERVFAEQ = ISNULL(MAX(VRSERVFATU), 0)
                 FROM SERVCLIE
                WHERE CDCLIENTE  = @V_CLIENTE   AND
                      CDFILIAL   = @CUR_CDFILIAL    AND
                      CDSERVFILI = @V_CDSERVPREQUI;

               IF @V_VRSERVFAEQ <> 0 BEGIN
        
                  SET @V_VRSERVTOTAL = @CUR_QTEFETIVOS * @CUR_VRSERVICO;
                  SET @V_QTEFETSERV  = ROUND((@V_VRSERVTOTAL /@V_VRSERVFAEQ),0);
                  SET @V_VRSERVICO   = @V_VRSERVFAEQ;

                  SELECT @V_EXISTE = COUNT(*)
                    FROM TRAB_APURAC_EQ
                   WHERE CDFILIALAPEQ   = @CUR_CDFILIAL   AND
                         NRAPURACEQ     = @P_NRAPURACGD              AND
                         CDCLIENTEAPEQ  = @V_CLIENTE  AND
                         CDSERVFILIAPEQ = @CUR_CDSERVFILI AND
                         CDSERVPREQUI   = @V_CDSERVPREQUI            AND
                         IDAJUSEFETAPEQ = 'S'                       AND
                         DTAPURACFATEQ  = @CUR_DATABASE     AND
                         ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);

                  IF (@V_EXISTE = 0) BEGIN
                     INSERT INTO TRAB_APURAC_EQ
                     (CDFILIALAPEQ, NRAPURACEQ, CDCLIENTEAPEQ,
                      CDSERVFILIAPEQ, CDPRODUTOAPEQ,
                      NREFETREALAPEQ, NREFETIVOSAPEQ,
                      VRPRECREALAPEQ, VRPRECUNITAPEQ,
                      IDAJUSEFETAPEQ, DTAPURACFATEQ, CDSERVPREQUI, IDPRODPRINAPEQ)
                     VALUES (@CUR_CDFILIAL, @P_NRAPURACGD, @V_CLIENTE,
                             @CUR_CDSERVFILI, @CUR_CDPRODUTO,
                             @CUR_QTEFETIVOS, @V_QTEFETSERV,
                             @V_VRSERVICO, @V_VRSERVICO,
                             'S',@CUR_DATABASE, @V_CDSERVPREQUI, 'N');
                  END
                  ELSE BEGIN
                     UPDATE TRAB_APURAC_EQ
                        SET NREFETIVOSAPEQ = NREFETIVOSAPEQ + @V_QTEFETSERV
                      WHERE CDFILIALAPEQ   = @CUR_CDFILIAL   AND
                            NRAPURACEQ     = @P_NRAPURACGD           AND
                            CDCLIENTEAPEQ  = @V_CLIENTE  AND
                            CDSERVFILIAPEQ = @CUR_CDSERVFILI AND
                            CDSERVPREQUI   = @V_CDSERVPREQUI         AND
                            IDAJUSEFETAPEQ = 'S'                    AND
                            DTAPURACFATEQ  = @CUR_DATABASE  AND
                            ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);

                  END;
               END;
            END
            ELSE BEGIN
               /*SE NAO UTILIZA, ENTAO INSERE NA TRAB_APURAC_GD*/
               INSERT INTO TRAB_APURAC_GD
                  (CDFILIALAPGD  ,  NRAPURACGD   , CDCLIENTEAPGD , CDSERVFILIAPGD, 
                   CDPRODUTOAPGD , NREFETREALAPGD, NREFETIVOSAPGD, VRPRECREALAPGD, 
                   VRPRECUNITAPGD, IDAJUSEFETAPGD, DTAPURACFATGD)
               VALUES (@CUR_CDFILIAL , @P_NRAPURACGD, @V_CLIENTE,
                       @CUR_CDSERVFILI, @CUR_CDPRODUTO,
                       @CUR_QTEFETIVOS, @CUR_QTEFETIVOS,
                       @CUR_VRSERVICO, @CUR_VRSERVICO,
                       'N',@CUR_DATABASE);
            END;           
         END;
      END;
      FETCH NEXT FROM @CUR_MINEFETMES INTO @CUR_CDFILIAL,
										   @CUR_NMTURNO,
										   @CUR_CDSERVFILI,
										   @CUR_QTEFETIVOS,
										   @CUR_DSMINEFET,
										   @CUR_CDPRODUTO,
										   @CUR_DATABASE,
										   @CUR_VRSERVICO;
   END;
   CLOSE @CUR_MINEFETMES;
   DEALLOCATE @CUR_MINEFETMES;

   /* ABRE O CURSOR */
   DECLARE C_DIRETA CURSOR FOR

   SELECT CDFILIAL,  CDCLIENTE,   CDSERVFILI, CDTURNO,
          DTFATURAM, CDGRSERVFAT, CDPRODUTO, VRSERVICO, VRSERVFATUDT,
          SUM(QTEFETIVOS)
   FROM SUM_EFETIVOS
   WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIN AND
         ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
         (CDFILIAL   = @P_CDFILIAL) AND
         (CDCLIENTE  = @P_CDCLIENTE OR @P_CDCLIENTE IS NULL)
   GROUP BY CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDTURNO,
            CDGRSERVFAT, CDPRODUTO, VRSERVICO, VRSERVFATUDT
   HAVING (SUM(QTEFETIVOS) <> 0) AND
          (((CDGRSERVFAT IS NULL OR CDGRSERVFAT = '') AND ('N' = 'N')) OR
           ((CDGRSERVFAT IS NOT NULL AND CDGRSERVFAT <> '') AND ('N' = 'S')));

   OPEN C_DIRETA;
   FETCH NEXT FROM C_DIRETA INTO @V_CDFILIAL,     @V_CDCLIENTE,   @V_CDSERVFILI, @V_CDTURNO,
                                 @V_DTFATURAM,    @V_CDGRSERVFAT, @V_CDPRODUTO,  @V_VRSERVICO,
                                 @V_VRSERVFATUDT, @V_QTEFETSERV;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      /* CALCULA O MINIMO DE EFETIVOS */
      SET @QTDEMINIEFET = TEKNISA.CALCEFETMINI(@V_CDFILIAL,
                                               @V_CDCLIENTE,
                                               @V_CDSERVFILI,
                                               @V_CDGRSERVFAT,
                                               @V_DTFATURAM);
      SET @V_VRSERVICO     = @V_VRSERVICO;
      SET @V_VRSERVREAL    = @V_VRSERVICO;
      SET @V_QTEFETSERV    = @V_QTEFETSERV;
      SET @V_QTEFETREAL    = @V_QTEFETSERV;  

      IF (@V_VRSERVFATUDT IS NOT NULL) AND (@V_VRSERVFATUDT <> 0) BEGIN
         SET @V_VRSERVICO = @V_VRSERVFATUDT;
      END;

      IF @V_CDTURNO IS NULL BEGIN
        -- EFETUA O AJUSTE DAS QUANTIDADES OU VALORES DOS SERVICOS --
        IF (@STIDMINIEFET = '1') BEGIN
        -- POR DIA
           IF (@STIDQTDEPREC = '1') BEGIN
           -- POR QUANTIDADE
              IF (@V_QTEFETSERV < @QTDEMINIEFET) BEGIN
                 SET @V_QTEFETSERV = @QTDEMINIEFET;
              END;
           END
           ELSE BEGIN
           -- POR PRECO
              SELECT @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
                     @V_VRPERCCORR = ISNULL(V_VRPERCCORR, 0)
                FROM PRECOCORR(@V_CDFILIAL,
                               @V_CDCLIENTE,
                               @V_CDSERVFILI,
                               @V_CDGRSERVFAT,
                               @V_QTEFETSERV,
                               @QTDEMINIEFET,
                               'S');
              END;
        END
        ELSE BEGIN
        -- POR PERIODO
           -- VERIFICA SE JA FOI GRAVADO REGISTRO PARA AJUSTE DE EFETIVOS POR QUANTIDADE --
           SELECT @V_EXISTE = COUNT(*)
           FROM TRAB_APURAC_GD
           WHERE CDFILIALAPGD   = @V_CDFILIAL    AND
                 NRAPURACGD     = @P_NRAPURACGD  AND
                 CDCLIENTEAPGD  = @V_CDCLIENTE   AND
                 CDSERVFILIAPGD = @V_CDSERVFILI  AND
                 DTAPURACFATGD  = @P_DATAFIN+1   AND
                 IDAJUSEFETAPGD = 'S';
           IF (@V_EXISTE = 0) BEGIN
              -- CALCULA O TOTAL DE EFETIVOS DO PERIODO --
              SELECT @V_TTEFETSERV = SUM(QTEFETIVOS)
              FROM SUM_EFETIVOS
              WHERE (DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIN) AND
                    ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
                    CDFILIAL   = @V_CDFILIAL                      AND
                    CDCLIENTE  = @V_CDCLIENTE                     AND
                    CDSERVFILI = @V_CDSERVFILI 

              IF (@STIDQTDEPREC = '1') BEGIN
              -- POR QUANTIDADE
                 IF (@V_TTEFETSERV < @QTDEMINIEFET) BEGIN
                   
                    SELECT @V_VRSERVFATU = MAX(VRSERVFATHIS)
                    FROM HISTSERVFATU
                    WHERE CDFILIAL     = @V_CDFILIAL   AND
                          CDCLIENTE    = @V_CDCLIENTE  AND
                          CDSERVFILI   = @V_CDSERVFILI AND
                          DTALTEFATHIS = (SELECT MAX(DTALTEFATHIS)
                                          FROM HISTSERVFATU H, (SELECT MAX(DTSRVFATUHIS) AS DTSRVFATUHIS
                                                                FROM HISTSERVFATU
                                                                WHERE CDFILIAL = @V_CDFILIAL     AND  
                                                                      CDCLIENTE = @V_CDCLIENTE   AND
                                                                      CDSERVFILI = @V_CDSERVFILI AND
                                                                      DTSRVFATUHIS <= @V_DTFATURAM) X
                                         WHERE H.CDFILIAL   = @V_CDFILIAL       AND
                                               H.CDCLIENTE    = @V_CDCLIENTE    AND
                                               H.CDSERVFILI   = @V_CDSERVFILI   AND
                                               H.DTSRVFATUHIS = X.DTSRVFATUHIS) AND
                          DTSRVFATUHIS = (SELECT MAX(DTSRVFATUHIS) AS DTSRVFATUHIS
                                          FROM HISTSERVFATU
                                          WHERE CDFILIAL      = @V_CDFILIAL   AND
                                                CDCLIENTE     = @V_CDCLIENTE  AND
                                                CDSERVFILI    = @V_CDSERVFILI AND
                                                DTSRVFATUHIS <= @V_DTFATURAM);
                    IF (@V_VRSERVFATU IS NULL) BEGIN
                       SELECT @V_VRSERVFATU = VRSERVFATU
                       FROM SERVCLIE
                       WHERE CDFILIAL   = @V_CDFILIAL  AND
                             CDCLIENTE  = @V_CDCLIENTE AND
                             CDSERVFILI = @V_CDSERVFILI;

                       IF (@V_VRSERVFATU IS NULL) BEGIN
                          SET @V_VRSERVFATU = 0;
                       END;
                    END;

                    -- GRAVA O AJUSTE DA QUANTIDADE DE EFETIVOS
                    INSERT INTO TRAB_APURAC_GD
                    (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
                     CDSERVFILIAPGD, CDPRODUTOAPGD,
                     NREFETREALAPGD, NREFETIVOSAPGD,
                     VRPRECREALAPGD, VRPRECUNITAPGD,
                     IDAJUSEFETAPGD, DTAPURACFATGD)
                    VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                            @V_CDSERVFILI, @V_CDPRODUTO,
                           (@QTDEMINIEFET-@V_TTEFETSERV), (@QTDEMINIEFET-@V_TTEFETSERV),
                            @V_VRSERVFATU, @V_VRSERVFATU,
                            'S',@P_DATAFIN+1);
                  END;
              END
              ELSE BEGIN
              -- POR PRECO
                 IF (@V_TTEFETSERV < @QTDEMINIEFET) BEGIN
                    SELECT @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
                           @V_VRPERCCORR = ISNULL(V_VRPERCCORR, 0)
                    FROM PRECOCORR(@V_CDFILIAL,
                                   @V_CDCLIENTE,
                                   @V_CDSERVFILI,
                                   @V_CDGRSERVFAT,
                                   @V_QTEFETSERV,
                                   @QTDEMINIEFET,
                                   'S');
                 END; 
              END;
           END;
        END;
     END;

      /* EQUIVALENCIA DE SERVICOS */
      SELECT @V_CDSERVPREQUI = ISNULL(MAX(CDSERVPREQUI),NULL)
      FROM SERVICO
      WHERE CDSERVFILI = @V_CDSERVFILI AND
            CDFILIAL   = @V_CDFILIAL;

      IF (@V_CDSERVPREQUI IS NOT NULL) BEGIN
          SELECT @V_VRSERVFAEQ = ISNULL(MAX(VRSERVFATU), 0)
          FROM SERVCLIE
          WHERE CDCLIENTE  = @V_CDCLIENTE   AND
                CDFILIAL   = @V_CDFILIAL    AND
                CDSERVFILI = @V_CDSERVPREQUI;

          IF @V_VRSERVFAEQ <> 0 BEGIN

             SET @V_VRSERVTOTAL = @V_QTEFETSERV * @V_VRSERVICO;
             SET @V_QTEFETSERV  = ROUND(@V_VRSERVTOTAL/@V_VRSERVFAEQ, 0);
             SET @V_VRSERVICO   = @V_VRSERVFAEQ;

             SELECT @V_EXISTE = COUNT(*)
             FROM TRAB_APURAC_EQ
             WHERE CDFILIALAPEQ   = @V_CDFILIAL            AND
                   NRAPURACEQ     = @P_NRAPURACGD          AND
                   CDCLIENTEAPEQ  = @V_CDCLIENTE           AND
                   CDSERVFILIAPEQ = @V_CDSERVFILI          AND
                   CDSERVPREQUI   = @V_CDSERVPREQUI        AND
                   IDAJUSEFETAPEQ = 'S'                    AND
                   DTAPURACFATEQ  = @V_DTFATURAM           AND
                   ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);

             IF (@V_EXISTE = 0) BEGIN
                INSERT INTO TRAB_APURAC_EQ
                (CDFILIALAPEQ, NRAPURACEQ, CDCLIENTEAPEQ,
                 CDSERVFILIAPEQ, CDPRODUTOAPEQ,
                 NREFETREALAPEQ, NREFETIVOSAPEQ,
                 VRPRECREALAPEQ, VRPRECUNITAPEQ,
                 IDAJUSEFETAPEQ, DTAPURACFATEQ, CDSERVPREQUI, IDPRODPRINAPEQ)
                VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                        @V_CDSERVFILI, @V_CDPRODUTO,
                        @V_QTEFETREAL, @V_QTEFETSERV,
                        @V_VRSERVREAL, @V_VRSERVICO,
                        'S',@V_DTFATURAM, @V_CDSERVPREQUI, 'N');
             END
             ELSE BEGIN
                UPDATE TRAB_APURAC_EQ
                SET NREFETIVOSAPEQ = NREFETIVOSAPEQ + @V_QTEFETSERV
                WHERE CDFILIALAPEQ   = @V_CDFILIAL            AND
                      NRAPURACEQ     = @P_NRAPURACGD          AND
                      CDCLIENTEAPEQ  = @V_CDCLIENTE           AND
                      CDSERVFILIAPEQ = @V_CDSERVFILI          AND
                      CDSERVPREQUI   = @V_CDSERVPREQUI        AND
                      IDAJUSEFETAPEQ = 'S'                    AND
                      DTAPURACFATEQ  = @V_DTFATURAM           AND
                      ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);
            END;
        END; 

        FETCH NEXT FROM C_DIRETA INTO @V_CDFILIAL,     @V_CDCLIENTE,   @V_CDSERVFILI, @V_CDTURNO,
                                      @V_DTFATURAM,    @V_CDGRSERVFAT, @V_CDPRODUTO,  @V_VRSERVICO,
                                      @V_VRSERVFATUDT, @V_QTEFETSERV;

    END
    ELSE BEGIN

      IF (@V_CDTURNO IS NOT NULL) BEGIN
         /* GRAVA OS SERVICOS NA TRAB_APURAC_TU JA COM AS QUANTIDADES E VALORES CORRIGIDOS */
         SELECT @V_EXISTE = COUNT(*)
         FROM TRAB_APURAC_TU
         WHERE CDFILIALAPTU   = @V_CDFILIAL    AND
               NRAPURACTU     = @P_NRAPURACGD  AND
               CDCLIENTEAPTU  = @V_CDCLIENTE   AND
               CDSERVFILIAPTU = @V_CDSERVFILI  AND
               DTAPURACFATTU  = @V_DTFATURAM   AND
               CDTURNOTU      = @V_CDTURNO     AND
               ROUND(VRPRECUNITAPTU,2) = ROUND(@V_VRSERVICO,2);

         IF (@V_EXISTE = 0) BEGIN
            INSERT INTO TRAB_APURAC_TU
            (CDFILIALAPTU, NRAPURACTU, CDCLIENTEAPTU,
             CDSERVFILIAPTU, CDPRODUTOAPTU,
             NREFETREALAPTU, NREFETIVOSAPTU,
             VRPRECREALAPTU, VRPRECUNITAPTU,
             IDAJUSEFETAPTU, DTAPURACFATTU,CDTURNOTU)
            VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                    @V_CDSERVFILI, @V_CDPRODUTO,
                    @V_QTEFETREAL, @V_QTEFETSERV,
                    @V_VRSERVREAL, @V_VRSERVICO,
                    'N', @V_DTFATURAM, @V_CDTURNO);
         END
         ELSE BEGIN
            UPDATE TRAB_APURAC_TU
            SET NREFETIVOSAPTU = NREFETIVOSAPTU + @V_QTEFETSERV
            WHERE CDFILIALAPTU   = @V_CDFILIAL   AND
                  NRAPURACTU     = @P_NRAPURACGD AND
                  CDCLIENTEAPTU  = @V_CDCLIENTE  AND
                  CDSERVFILIAPTU = @V_CDSERVFILI AND
                  DTAPURACFATTU  = @V_DTFATURAM   AND
                  CDTURNOTU      = @V_CDTURNO     AND
                  ROUND(VRPRECUNITAPTU,2) = ROUND(@V_VRSERVICO,2);
         END;

         FETCH NEXT FROM C_DIRETA INTO @V_CDFILIAL,     @V_CDCLIENTE,   @V_CDSERVFILI, @V_CDTURNO,
                                       @V_DTFATURAM,    @V_CDGRSERVFAT, @V_CDPRODUTO,  @V_VRSERVICO,
                                       @V_VRSERVFATUDT, @V_QTEFETSERV;
      END
      ELSE BEGIN
         /* GRAVA OS SERVICOS NA TRAB_APURAC_GD JA COM AS QUANTIDADES E VALORES CORRIGIDOS */
         SELECT @V_EXISTE = COUNT(*)
         FROM TRAB_APURAC_GD
         WHERE CDFILIALAPGD   = @V_CDFILIAL   AND
               NRAPURACGD     = @P_NRAPURACGD AND
               CDCLIENTEAPGD  = @V_CDCLIENTE  AND
               CDSERVFILIAPGD = @V_CDSERVFILI AND
               CDPRODUTOAPGD  = @V_CDPRODUTO  AND
               DTAPURACFATGD  = @V_DTFATURAM  AND
               ROUND(VRPRECUNITAPGD,2) = ROUND(@V_VRSERVICO,2);

         IF (@V_EXISTE = 0) BEGIN
            INSERT INTO TRAB_APURAC_GD
            (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
             CDSERVFILIAPGD, CDPRODUTOAPGD,
             NREFETREALAPGD, NREFETIVOSAPGD,
             VRPRECREALAPGD, VRPRECUNITAPGD,
             IDAJUSEFETAPGD, DTAPURACFATGD)
            VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                    @V_CDSERVFILI, @V_CDPRODUTO,
                    @V_QTEFETREAL, @V_QTEFETSERV,
                    @V_VRSERVREAL, @V_VRSERVICO,
                    'N',@V_DTFATURAM);
         END
         ELSE BEGIN
            UPDATE TRAB_APURAC_GD
            SET NREFETIVOSAPGD = NREFETIVOSAPGD  + @V_QTEFETSERV
            WHERE CDFILIALAPGD   = @V_CDFILIAL   AND
                  NRAPURACGD     = @P_NRAPURACGD AND
                  CDCLIENTEAPGD  = @V_CDCLIENTE  AND
                  CDSERVFILIAPGD = @V_CDSERVFILI AND
                  CDPRODUTOAPGD  = @V_CDPRODUTO  AND
                  DTAPURACFATGD  = @V_DTFATURAM  AND
                  ROUND(VRPRECUNITAPGD,2) = ROUND(@V_VRSERVICO,2);
                                    
         END;
         FETCH NEXT FROM C_DIRETA INTO @V_CDFILIAL,     @V_CDCLIENTE,   @V_CDSERVFILI, @V_CDTURNO,
                                       @V_DTFATURAM,    @V_CDGRSERVFAT, @V_CDPRODUTO,  @V_VRSERVICO,
                                       @V_VRSERVFATUDT, @V_QTEFETSERV;
         END;
       END;
     END;
   CLOSE C_DIRETA;
   DEALLOCATE C_DIRETA;


 /* ABRE O CURSOR PARA TODOS OS SERVICOS QUE POSSUEM GRUPOS */
   DECLARE C_GDIRETA CURSOR FOR
   SELECT CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, NULL CDTURNO, CDGRSERVFAT,
          CDPRODUTO, VRSERVICO, SUM(QTEFETIVOS)
   FROM SUM_EFETIVOS
   WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIN   AND
         ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
         (CDFILIAL   = @P_CDFILIAL) AND
         (CDCLIENTE  = @P_CDCLIENTE OR @P_CDCLIENTE IS NULL)
   GROUP BY CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDTURNO, CDGRSERVFAT,
            CDPRODUTO, VRSERVICO
   HAVING (SUM(QTEFETIVOS) <> 0) AND
          (((CDGRSERVFAT IS NULL OR CDGRSERVFAT = '') AND ('S' = 'N')) OR
           ((CDGRSERVFAT IS NOT NULL AND CDGRSERVFAT <> '') AND ('S' = 'S')));
   OPEN C_GDIRETA;
   FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL,    @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                  @V_CDTURNO, @V_CDGRSERVFAT, @V_CDPRODUTO, @V_VRSERVICO, @V_QTEFETSERV;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      /* CALCULA O MINIMO DE EFETIVOS */
      SET @QTDEMINIEFET = TEKNISA.CALCEFETMINI(@V_CDFILIAL,
                                               @V_CDCLIENTE,
                                               @V_CDSERVFILI,
                                               @V_CDGRSERVFAT,
                                               @V_DTFATURAM);

      SET @V_VRSERVICO  = @V_VRSERVICO;
      SET @V_VRSERVREAL = @V_VRSERVICO;
      SET @V_QTEFETSERV = @V_QTEFETSERV;
      SET @V_QTEFETREAL = @V_QTEFETSERV;
   
      IF (@V_VRSERVFATUDT IS NOT NULL) AND (@V_VRSERVFATUDT <> 0)BEGIN
         SET @V_VRSERVICO = @V_VRSERVFATUDT;
      END;      

      IF @V_CDTURNO IS NULL BEGIN
         SELECT @V_QTEFETGRUP = SUM(QTEFETIVOS)
         FROM SUM_EFETIVOS
         WHERE (DTFATURAM = @V_DTFATURAM)                    AND
               ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
               CDFILIAL    = @V_CDFILIAL                     AND
               CDCLIENTE   = @V_CDCLIENTE                    AND
               CDGRSERVFAT = @V_CDGRSERVFAT;

         SELECT @V_CDSERVAJUS = CDSERAJEFEGSF
         FROM GRUPSERVFAT
         WHERE CDFILIAL    = @V_CDFILIAL           AND
               CDCLIENTE   = @V_CDCLIENTE          AND
               CDGRSERVFAT = @V_CDGRSERVFAT;

         /* EFETUA O AJUSTE DAS QUANTIDADES OU VALORES DOS SERVICOS */
         IF (@STIDMINIEFET = '1') BEGIN
            /* POR DIA*/
            IF (@STIDQTDEPREC = '1') BEGIN
            /* POR QUANTIDADE*/
               IF (@V_QTEFETGRUP < @QTDEMINIEFET) AND (@V_CDSERVFILI = @V_CDSERVAJUS) BEGIN
                 SET  @V_QTEFETSERV = @V_QTEFETSERV + (@QTDEMINIEFET - @V_QTEFETGRUP);
               END;
            END
            ELSE BEGIN
            /* POR PRECO */
              SELECT @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
                     @V_VRPERCCORR = ISNULL(V_VRPERCCORR, 0)
              FROM
                 PRECOCORR(@V_CDFILIAL,
                           @V_CDCLIENTE,
                           @V_CDSERVFILI,
                           @V_CDGRSERVFAT,
                           @V_QTEFETSERV,
                           @QTDEMINIEFET,
                           'G');
            END;
      END
      ELSE BEGIN
      /* POR PERIODO*/
      /* VERIFICA SE JA FOI GRAVADO REGISTRO PARA AJUSTE DE EFETIVOS POR QUANTIDADE */
           SELECT @V_EXISTE = COUNT(*)
           FROM TRAB_APURAC_GD
           WHERE CDFILIALAPGD   = @V_CDFILIAL    AND
                 NRAPURACGD     = @P_NRAPURACGD  AND
                 CDCLIENTEAPGD  = @V_CDCLIENTE   AND
                 CDSERVFILIAPGD = @V_CDSERVFILI  AND
                 DTAPURACFATGD  = @P_DATAFIN+1   AND
                 IDAJUSEFETAPGD = 'S';

           IF (@V_EXISTE = 0) BEGIN
           /* CALCULA O TOTAL DE EFETIVOS DO PERIODO */
              SELECT @V_QTEFETGRUP = SUM(QTEFETIVOS)
              FROM SUM_EFETIVOS
              WHERE (DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIN) AND
                    ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
                    CDFILIAL    = @V_CDFILIAL  AND
                    CDCLIENTE   = @V_CDCLIENTE AND
                    CDGRSERVFAT = @V_CDGRSERVFAT;

              IF (@STIDQTDEPREC = '1') BEGIN
              /* POR QUANTIDADE*/
                 IF (@V_QTEFETGRUP < @QTDEMINIEFET) AND (@V_CDSERVFILI = @V_CDSERVAJUS) BEGIN
                     SELECT @V_VRSERVFATU = MAX(VRSERVFATHIS)
                       FROM HISTSERVFATU
                      WHERE CDFILIAL     = @V_CDFILIAL   AND
                            CDCLIENTE    = @V_CDCLIENTE  AND
                            CDSERVFILI   = @V_CDSERVFILI AND
                            DTALTEFATHIS = (SELECT MAX(DTALTEFATHIS)
                                             FROM HISTSERVFATU H, (SELECT MAX(DTSRVFATUHIS) AS DTSRVFATUHIS
                                                                   FROM HISTSERVFATU
                                                                   WHERE CDFILIAL = @V_CDFILIAL   AND
                                                                         CDCLIENTE = @V_CDCLIENTE   AND
                                                                         CDSERVFILI = @V_CDSERVFILI AND
                                                                         DTSRVFATUHIS <= @V_DTFATURAM) X
                                            WHERE H.CDFILIAL    = @V_CDFILIAL     AND
                                                  H.CDCLIENTE   = @V_CDCLIENTE    AND
                                                  H.CDSERVFILI  = @V_CDSERVFILI   AND
                                                 H.DTSRVFATUHIS = X.DTSRVFATUHIS) AND
                             DTSRVFATUHIS = (SELECT MAX(DTSRVFATUHIS) AS DTSRVFATUHIS
                                             FROM HISTSERVFATU
                                             WHERE CDFILIAL     = @V_CDFILIAL    AND
                                                   CDCLIENTE    = @V_CDCLIENTE   AND
                                                   CDSERVFILI   = @V_CDSERVFILI  AND
                                                   DTSRVFATUHIS <= @V_DTFATURAM);

                 IF (@V_VRSERVFATU IS NULL) BEGIN
                    SELECT @V_VRSERVFATU = VRSERVFATU
                    FROM SERVCLIE
                    WHERE CDFILIAL   = @V_CDFILIAL  AND
                          CDCLIENTE  = @V_CDCLIENTE AND
                          CDSERVFILI = @V_CDSERVFILI;

                    IF (@V_VRSERVFATU IS NULL) BEGIN
                       SET @V_VRSERVFATU = 0;
                    END;
                 END;

                     /* GRAVA O AJUSTE DA QUANTIDADE DE EFETIVOS */
                    INSERT INTO TRAB_APURAC_GD
                    (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
                     CDSERVFILIAPGD, CDPRODUTOAPGD,
                     NREFETREALAPGD, NREFETIVOSAPGD,
                     VRPRECREALAPGD, VRPRECUNITAPGD,
                     IDAJUSEFETAPGD, DTAPURACFATGD)
                    VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                            @V_CDSERVFILI, @V_CDPRODUTO,
                            (@QTDEMINIEFET-@V_QTEFETGRUP), (@QTDEMINIEFET-@V_QTEFETGRUP),
                            @V_VRSERVFATU, @V_VRSERVFATU,
                            'S',@P_DATAFIN+1);
                 END;
              END
              ELSE BEGIN
                 /* POR PRECO*/
                 IF (@V_QTEFETGRUP < @QTDEMINIEFET) BEGIN
                    SELECT @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
                           @V_VRPERCCORR = ISNULL(V_VRPERCCORR, 0)
                    FROM
                       PRECOCORR(@V_CDFILIAL,
                                 @V_CDCLIENTE,
                                 @V_CDSERVFILI,
                                 @V_CDGRSERVFAT,
                                 @V_QTEFETSERV,
                                 @QTDEMINIEFET,
                                 'G');
                 END;
              END;
           END;
        END;
     END;
      

      /* EQUIVALENCIA DE SERVICOS */
      SELECT @V_CDSERVPREQUI = ISNULL(MAX(CDSERVPREQUI),NULL)
      FROM SERVICO
      WHERE CDSERVFILI = @V_CDSERVFILI AND
            CDFILIAL   = @V_CDFILIAL;

      IF @V_CDSERVPREQUI IS NOT NULL BEGIN
          SELECT @V_VRSERVFAEQ = ISNULL(MAX(VRSERVFATU), 0)
          FROM SERVCLIE
          WHERE CDCLIENTE  = @V_CDCLIENTE   AND
                CDFILIAL   = @V_CDFILIAL    AND
                CDSERVFILI = @V_CDSERVPREQUI;

          IF @V_VRSERVFAEQ <> 0 BEGIN

             SET @V_VRSERVTOTAL = @V_QTEFETSERV * @V_VRSERVICO;
             SET @V_QTEFETSERV  = ROUND(@V_VRSERVTOTAL/@V_VRSERVFAEQ, 0);
             SET @V_VRSERVICO   = @V_VRSERVFAEQ;

             SELECT @V_EXISTE = COUNT(*)
             FROM TRAB_APURAC_EQ
             WHERE CDFILIALAPEQ   = @V_CDFILIAL     AND
                   NRAPURACEQ     = @P_NRAPURACGD   AND
                   CDCLIENTEAPEQ  = @V_CDCLIENTE    AND
                   CDSERVFILIAPEQ = @V_CDSERVFILI   AND
                   CDSERVPREQUI   = @V_CDSERVPREQUI AND
                   IDAJUSEFETAPEQ = 'S'             AND
                   DTAPURACFATEQ  = @V_DTFATURAM    AND
                   ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);

             IF (@V_EXISTE = 0) BEGIN
                INSERT INTO TRAB_APURAC_EQ
                (CDFILIALAPEQ, NRAPURACEQ, CDCLIENTEAPEQ,
                 CDSERVFILIAPEQ, CDPRODUTOAPEQ,
                 NREFETREALAPEQ, NREFETIVOSAPEQ,
                 VRPRECREALAPEQ, VRPRECUNITAPEQ,
                 IDAJUSEFETAPEQ, DTAPURACFATEQ, CDSERVPREQUI, IDPRODPRINAPEQ)
                VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                        @V_CDSERVFILI, @V_CDPRODUTO,
                        @V_QTEFETREAL, @V_QTEFETSERV,
                        @V_VRSERVREAL, @V_VRSERVICO,
                        'S',@V_DTFATURAM, @V_CDSERVPREQUI,'N');

             END
             ELSE BEGIN
                UPDATE TRAB_APURAC_EQ
                SET NREFETIVOSAPEQ = NREFETIVOSAPEQ + @V_QTEFETSERV
                WHERE CDFILIALAPEQ   = @V_CDFILIAL     AND
                      NRAPURACEQ     = @P_NRAPURACGD   AND
                      CDCLIENTEAPEQ  = @V_CDCLIENTE    AND
                      CDSERVFILIAPEQ = @V_CDSERVFILI   AND
                      CDSERVPREQUI   = @V_CDSERVPREQUI AND
                      IDAJUSEFETAPEQ = 'S'             AND
                      DTAPURACFATEQ  = @V_DTFATURAM    AND
                      ROUND(VRPRECUNITAPEQ,2) = ROUND(@V_VRSERVICO,2);

             END;
          FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL,    @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                         @V_CDTURNO, @V_CDGRSERVFAT, @V_CDPRODUTO, @V_VRSERVICO, @V_QTEFETSERV;
          END;
      END
      ELSE BEGIN
         IF @V_CDTURNO IS NOT NULL BEGIN
            /* GRAVA OS SERVICOS NA TRAB_APURAC_TU JA COM AS QUANTIDADES E VALORES CORRIGIDOS */
            SELECT @V_EXISTE = COUNT(*)
            FROM TRAB_APURAC_TU
            WHERE CDFILIALAPTU   = @V_CDFILIAL   AND
                  NRAPURACTU     = @P_NRAPURACGD AND
                  CDCLIENTEAPTU  = @V_CDCLIENTE  AND
                  CDSERVFILIAPTU = @V_CDSERVFILI AND
                  DTAPURACFATTU  = @V_DTFATURAM  AND
                  CDTURNOTU      = @V_CDTURNO    AND
                  ROUND(VRPRECUNITAPTU,2) = ROUND(@V_VRSERVICO,2);

            IF (@V_EXISTE = 0) BEGIN
               INSERT INTO TRAB_APURAC_TU
               (CDFILIALAPTU, NRAPURACTU, CDCLIENTEAPTU,
                CDSERVFILIAPTU, CDPRODUTOAPTU,
                NREFETREALAPTU, NREFETIVOSAPTU,
                VRPRECREALAPTU, VRPRECUNITAPTU,
                IDAJUSEFETAPTU, DTAPURACFATTU,CDTURNOTU)
               VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                       @V_CDSERVFILI, @V_CDPRODUTO,
                       @V_QTEFETREAL, @V_QTEFETSERV,
                       @V_VRSERVREAL, @V_VRSERVICO,
                       'N',@V_DTFATURAM, @V_CDTURNO);

            END 
            ELSE BEGIN
               UPDATE TRAB_APURAC_TU
               SET NREFETIVOSAPTU = NREFETIVOSAPTU + @V_QTEFETSERV
               WHERE CDFILIALAPTU   = @V_CDFILIAL   AND
                     NRAPURACTU     = @P_NRAPURACGD AND
                     CDCLIENTEAPTU  = @V_CDCLIENTE  AND
                     CDSERVFILIAPTU = @V_CDSERVFILI AND
                     DTAPURACFATTU  = @V_DTFATURAM   AND
                     CDTURNOTU      = @V_CDTURNO     AND
                     ROUND(VRPRECUNITAPTU,2) = ROUND(@V_VRSERVICO,2);
            END;
            FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL,    @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                           @V_CDTURNO, @V_CDGRSERVFAT, @V_CDPRODUTO, @V_VRSERVICO, @V_QTEFETSERV;
         END
         ELSE BEGIN
            /* GRAVA OS SERVICOS NA TRAB_APURAC_GD JA COM AS QUANTIDADES E VALORES CORRIGIDOS */
            SELECT @V_EXISTE = COUNT(*)
            FROM TRAB_APURAC_GD
            WHERE CDFILIALAPGD   = @V_CDFILIAL   AND
                  NRAPURACGD     = @P_NRAPURACGD AND
                  CDCLIENTEAPGD  = @V_CDCLIENTE  AND
                  CDSERVFILIAPGD = @V_CDSERVFILI AND
                  CDPRODUTOAPGD  = @V_CDPRODUTO  AND
                  DTAPURACFATGD  = @V_DTFATURAM  AND
                  ROUND(VRPRECUNITAPGD,2) = ROUND(@V_VRSERVICO,2);

            IF (@V_EXISTE = 0) BEGIN
               INSERT INTO TRAB_APURAC_GD
               (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
                CDSERVFILIAPGD, CDPRODUTOAPGD,
                NREFETREALAPGD, NREFETIVOSAPGD,
                VRPRECREALAPGD, VRPRECUNITAPGD,
                IDAJUSEFETAPGD, DTAPURACFATGD)
               VALUES (@V_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE,
                       @V_CDSERVFILI, @V_CDPRODUTO,
                       @V_QTEFETREAL, @V_QTEFETSERV,
                       @V_VRSERVREAL, @V_VRSERVICO,
                       'N',@V_DTFATURAM);

            END 
            ELSE BEGIN
               UPDATE TRAB_APURAC_GD
               SET NREFETIVOSAPGD = NREFETIVOSAPGD + @V_QTEFETSERV
               WHERE CDFILIALAPGD   = @V_CDFILIAL   AND
                     NRAPURACGD     = @P_NRAPURACGD AND
                     CDCLIENTEAPGD  = @V_CDCLIENTE  AND
                     CDSERVFILIAPGD = @V_CDSERVFILI AND
                     CDPRODUTOAPGD  = @V_CDPRODUTO  AND
                     DTAPURACFATGD  = @V_DTFATURAM  AND
                     ROUND(VRPRECUNITAPGD,2) = ROUND(@V_VRSERVICO,2);

            END;
	    FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL,    @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                       @V_CDTURNO,    @V_CDGRSERVFAT, @V_CDPRODUTO, @V_VRSERVICO, @V_QTEFETSERV;
         END;
      END;
   END;
   CLOSE C_GDIRETA;
   DEALLOCATE C_GDIRETA;

  DECLARE C_PRODPRINCEQ CURSOR FOR
   
   SELECT
    B.CDCLIENTE, B.CDSERVICO, B.CDSERVPREQUI, B.CDSERVFILIAPEQ, B.NMSERVICO,
    B.DTAPURACFATEQ, B.QTDEREFE,
    (B.VRPRECUNITAPEQ) AS VRFATUSERV, B.VRIMPOSTO, B.CDPRODUTO
      FROM
         (SELECT TE.CDCLIENTEAPEQ AS CDCLIENTE, TE.CDSERVPREQUI AS CDSERVICO, TE.CDSERVPREQUI, 'XXXXX' AS CDSERVFILIAPEQ, S.NMSERVICO,
                 TE.DTAPURACFATEQ, ROUND(SUM(TE.NREFETIVOSAPEQ),0) QTDEREFE,
                 TE.VRPRECUNITAPEQ, ISNULL(SUM(VRIMPOSPRODEQ),0) AS VRIMPOSTO, S.CDPRODUTO
            FROM SERVICO S, TRAB_APURAC_EQ TE
           WHERE CDFILIALAPEQ   = @P_CDFILIAL     AND
                 DTAPURACFATEQ BETWEEN @P_DATAINI AND @P_DATAFIN AND
                 NRAPURACEQ     = @P_NRAPURACGD   AND
                 S.CDFILIAL     = TE.CDFILIALAPEQ AND
                 S.CDSERVFILI   = TE.CDSERVPREQUI AND
                 TE.IDAJUSEFETAPEQ = 'S'
        GROUP BY TE.CDCLIENTEAPEQ, TE.CDSERVPREQUI, S.NMSERVICO, TE.DTAPURACFATEQ, TE.VRPRECUNITAPEQ, S.CDPRODUTO
         ) B

   OPEN C_PRODPRINCEQ;
   FETCH NEXT FROM C_PRODPRINCEQ INTO @V_CDCLIENTE, @V_CDSERVFILI, @V_CDSERVPREQUI, @V_CDSERVFILI, @V_NMSERVICO,
                                      @V_DTFATURAM, @V_QTDEREFE,   @V_VRSERVFATUDT, @V_VRIMPOSTO,  @V_CDPRODUTO;
                                 
   
   WHILE (@@FETCH_STATUS = 0) BEGIN

      INSERT INTO TRAB_APURAC_EQ
             (CDFILIALAPEQ, NRAPURACEQ, CDCLIENTEAPEQ, CDSERVFILIAPEQ, CDPRODUTOAPEQ,
              NREFETREALAPEQ, NREFETIVOSAPEQ, VRPRECREALAPEQ, VRPRECUNITAPEQ,
              IDAJUSEFETAPEQ, DTAPURACFATEQ, CDSERVPREQUI, IDPRODPRINAPEQ)
      VALUES (@P_CDFILIAL, @P_NRAPURACGD, @V_CDCLIENTE, @V_CDSERVFILI, @V_CDPRODUTO,
              @V_QTDEREFE, @V_QTDEREFE, @V_VRSERVFATUDT, @V_VRSERVFATUDT,
              'S',@V_DTFATURAM, @V_CDSERVPREQUI, 'S');

   FETCH NEXT FROM C_PRODPRINCEQ INTO @V_CDCLIENTE, @V_CDSERVFILI, @V_CDSERVPREQUI, @V_CDSERVFILI, @V_NMSERVICO,
                                      @V_DTFATURAM, @V_QTDEREFE,   @V_VRSERVFATUDT, @V_VRIMPOSTO,  @V_CDPRODUTO;

  END;
  CLOSE C_PRODPRINCEQ;
  DEALLOCATE C_PRODPRINCEQ;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURAC_RELGESDIRETA','5.85.000';
GO